package com.retailstore.ordermanagement.service;

import com.retailstore.ordermanagement.constants.Category;
import com.retailstore.ordermanagement.constants.Color;
import com.retailstore.ordermanagement.constants.Gender;
import com.retailstore.ordermanagement.constants.Size;
import com.retailstore.ordermanagement.model.Order;
import com.retailstore.ordermanagement.model.OrderedProduct;
import com.retailstore.ordermanagement.utils.Utility;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.Spy;

import java.sql.Connection;
import java.time.LocalDate;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

class RetailStoreTest {
    @Mock
    Connection connection;
    RetailStoreService service;
    @Spy
    @InjectMocks
    Utility utility;

    @BeforeEach
    void createretailsStoreObject() {
        service = new RetailStoreService();
    }

    @AfterEach
    void removeretailsStoreObject() {
        service = null;
    }

    @Test
    void addProducts() {
        LinkedHashMap<Size, Integer> sizeMap = new LinkedHashMap<>();
        sizeMap.put(Size.S, 2);
        sizeMap.put(Size.M, 2);
        sizeMap.put(Size.L, 2);
        sizeMap.put(Size.XL, 2);
        sizeMap.put(Size.XXL, 2);
        Mockito.when(utility.productIdGenerator()).thenReturn("TestMethod" + LocalDate.now() + LocalTime.now());
        Mockito.when(Utility.getScanner().nextLine()).thenReturn("TestProduct");
        Mockito.when(Utility.getCategory(true, "Test check")).thenReturn(Category.JEANS);
        Mockito.when(Utility.getColor(true, "Test check")).thenReturn(Color.BLACK);
        Mockito.when(Utility.getGender(true, "Test check")).thenReturn(Gender.WOMEN);
        Mockito.when(Utility.getDouble(true, "Test price")).thenReturn(1350.00);
        Mockito.when(Utility.getProductSizes()).thenReturn(sizeMap);
        Assertions.assertEquals(true, service.addProducts());
    }

    @Test
    void placeOrders() {

    }

    @Test
    void showOrdersTest() {
        Map<Integer, Order> ordersMap = Mockito.mock(LinkedHashMap.class);
        List<OrderedProduct> orderedProductList = Mockito.mock(ArrayList.class);
        ordersMap.put(1, new Order("10bc46f3#Order", LocalDate.now(), LocalTime.now(), "Customer", "9633214574", 2500.00, new ArrayList<OrderedProduct>()));
        Mockito.when(service.getOrders(connection)).thenReturn(ordersMap);
    }

    @Test
    void createOrder() {
        ArrayList<OrderedProduct> orderedProducts = new ArrayList<>();
        orderedProducts.add(new OrderedProduct("test1", "testname", Category.JEANS, Color.BLACK, 1200.00, Gender.MEN, Size.L, 2));
//        Mockito.when(getGender(true, "Test check")).thenReturn(Gender.WOMEN);
    }

    @Test
    void addProductToCart() {
    }
}